PROGRAM DECODE;

 TYPE BYTET=0..0FF(16); NIBBLE= 0..0F(16);
  FILENAME= ARRAY[3..14] OF CHAR;
  EXTENSION=(XBIN,XTXT);
  ANSWER=(NO,YES);
  OPTIONS=(HEADERS,CHOICE,LIST);
  BINFILE = FILE OF BYTET;

  PCODES=(
    PC00,LDIBPC,LDIWPC,LDISPC,STIBPC,STIWPC,STISPC,LDCPC,LNCPC,
         LCAPC,LDCSPC,LNSPC,SGSPC,DECPC,INCPC,DEC1PC,
    PC10,INC1PC,LTPC,EQPC,LEPC,LTMPC,EQMPC,LEMPC,LTSPC,EQSPC,LESPC,
         FJPC,UJPC,ANDPC,ORPC,NOTPC,
    PC20,DIFPC,INTPC,UNIPC,INPC,CARDPC,ADIPC,DVIPC,MODPC,MPIPC,
         NGIPC,SBIPC,ODDPC,MST0PC,MSTNPC,RETPC,
    PC30,CSPPC,CAPPC,CUP1PC,CUP2PC,FIX21PC,CASEPC,MOVEPC,FORPC,
         GSSPC,ILLPC);

 VAR P, LAST:INTEGER;
  OP, T1: INTEGER;
  RT: 0..9;
  NAME:ARRAY[1..8] OF CHAR;
  PROC: INTEGER;
  ENDP: BOOLEAN;
  HEXC:ARRAY[NIBBLE] OF CHAR;
  OPT: OPTIONS;

  VARSIZE, VARADDR: INTEGER;
  VALUEPART, EXTERNALPROCEDURE: BOOLEAN;

  LGO: BINFILE;
  FN : FILENAME;
  BIN: ARRAY[0..10000] OF BYTET;

VALUE 
  HEXC='0123456789ABCDEF';
  ENDP=FALSE;
  PROC=0;
  NAME='        ';
  FN=(12 OF COL);
  RT=0; OP=0; T1=0;
  VALUEPART=FALSE;
  EXTERNALPROCEDURE=FALSE;

  PROCEDURE LOAD;
   VAR ADDR: INTEGER; PEND: BOOLEAN;
     I, J, B: INTEGER;
     REP, SIZE: INTEGER;

   FUNCTION BYTE:BYTET;
     BEGIN BYTE:=LGO^; GET(LGO) END;

   BEGIN P:=0; PEND:=FALSE;
   REPEAT RT:=BYTE;
       CASE RT OF
        1: BEGIN B:=BYTE;
             FOR I:=1 TO B DO
               BEGIN BIN[P]:=BYTE;
               P:=P+1
               END
             END;
        2: BEGIN ADDR:=BYTE*256+BYTE;
             BIN[ADDR  ]:=BYTE;
             BIN[ADDR+1]:=BYTE
             END;
      4,8: BEGIN PROC:=BYTE;
             EXTERNALPROCEDURE:=RT=8;
             PEND:=TRUE; VALUEPART:=FALSE;
             FOR I:=1 TO 8 DO NAME[I]:=CHR(BYTE)
             END;
        5: BEGIN VALUEPART:=TRUE;
             PEND:=TRUE;
             VARSIZE:=BYTE*256+BYTE
           END;
        6: BEGIN VARADDR:=BYTE*256+BYTE;
             PEND:=TRUE
           END;
        7: BEGIN REP:=BYTE*256+BYTE;
             SIZE:=BYTE*256+BYTE;
             J:=P-SIZE;
             FOR I:=J TO J+REP-1 DO
               BEGIN BIN[P]:=BIN[I]; P:=P+1 END;
           END;
        9: BEGIN PEND:=TRUE; ENDP:=TRUE END
        END;
     UNTIL PEND;
    END;

  PROCEDURE LISTBINARY;
   VAR I, J: INTEGER; OP: INTEGER;

   FUNCTION BYTE:INTEGER;
    BEGIN BYTE:=BIN[P]; P:=P+1 END;

   FUNCTION BYTE2: INTEGER;
    BEGIN BYTE2:=BYTE*256+BYTE END;

   PROCEDURE PACOP;
  VAR J:INTEGER;
    BEGIN
    I:=OP MOD 16;
    OP:=OP DIV 16;
    CASE OP OF 
      0: WRITE('LDC #');
      1: WRITE('LEA ');
      2: BEGIN WRITE('LEA ');
          J:=(256-BYTE)*256-BYTE;
          WRITE(J:1,' :')
         END;
      3: WRITE('LDB ');
      4: WRITE('LDI ');
      5: WRITE('STB ');
      6: WRITE('STI ');
      7: WRITE('ALLOC,',BYTE2:1,' :')
      END;
    IF OP IN [1,3,4,5,6] THEN WRITE(256-BYTE,':');
    WRITELN(I:0);
    END;

     PROCEDURE HEX(C: NIBBLE);
      VAR I,J:INTEGER;
      BEGIN
      FOR I:=1 TO C DO
        BEGIN J:=BYTE;
        WRITE(HEXC[J DIV 16]);
        WRITE(HEXC[J MOD 16])
        END;
      END;

   PROCEDURE FULLOP;
     VAR I,J:INTEGER;
       DOP: PCODES;

     PROCEDURE STANDARDPROC;
       BEGIN I:=BYTE;
       WRITE('CALL ');
       CASE I OF 
         0: WRITE('WRI');
         1: WRITE('WRC');
         2: WRITE('WRS');
         3: WRITE('RDI');
         4: WRITE('RLN');
         5: WRITE('RDC');
         6: WRITE('WLN');
         7: WRITE('NEW');
         8: WRITE('EFL');
         9: WRITE('RST');
        10: WRITE('ELN');
        11: WRITE('STP');
        12: WRITE('HLT');
        13: WRITE('MSG');
        15: WRITE('GET');
        16: WRITE('PUT');
        17: WRITE('RESET');
        18: WRITE('REWRITE')
        END
      END;

     PROCEDURE CASESTATEMENT;
       VAR I, J:INTEGER;
       BEGIN I:=BYTE2; J:=BYTE2;
       WRITELN('CASE ',I,'< >',J,' OTHERWISE ',BYTE2);
       FOR I:=0 TO J-I DO
         WRITELN('  --',I:3,': ',BYTE2);
       END;

     BEGIN
     DOP:=PC00;
     FOR I:=129 TO OP DO DOP:=SUCC(DOP);
     CASE DOP OF
       LDIBPC: WRITE('LDIB');
       LDIWPC: WRITE('LDIW');
       LDISPC: WRITE('LDIS');
       STIBPC: WRITE('STIB');
       STIWPC: WRITE('STIW');
       STISPC: WRITE('STIS');
       LDCPC : WRITE('LDC #',BYTE2:1);
       LNCPC : WRITE('LDC -#',BYTE2:1);
       LCAPC : BEGIN I:=BYTE; WRITE('LCA ',I:3,' '); HEX(I) END;
       LDCSPC: BEGIN WRITE('LDCS '); HEX(8) END;
       LNSPC : WRITE('LOAD []');
       SGSPC : WRITE('LOAD [ I ]');
       DECPC : WRITE('DEC ',BYTE2:1);
       INCPC : WRITE('INC ',BYTE2:1);
       DEC1PC: WRITE('DEC1');
       INC1PC: WRITE('INC1');
       LTPC  : WRITE('LT_I');
       EQPC  : WRITE('EQ_I');
       LEPC  : WRITE('LE_I');
       LTMPC : WRITE('LT_M ',BYTE2:1);
       EQMPC : WRITE('EQ_M ',BYTE2:1);
       LEMPC : WRITE('LE_M ',BYTE2:1);
       LTSPC : WRITE('LE_S');
       EQSPC : WRITE('EQ_S');
       LESPC : WRITE('LE_S');
       FJPC  : WRITE('F_JUMP #',BYTE2:1);
       UJPC  : WRITE('JUMP #',BYTE2:1);
       ANDPC : WRITE('AND');
       ORPC  : WRITE('OR');
       NOTPC : WRITE('NOT');
       DIFPC : WRITE('SET DIF');
       INTPC : WRITE('SET INT');
       UNIPC : WRITE('SET UNION');
       INPC  : WRITE('IN SET');
       CARDPC: WRITE('SET CARD');
       ADIPC : WRITE('ADD');
       DVIPC : WRITE('DIV');
       MODPC : WRITE('MOD');
       MPIPC : WRITE('MULT');
       NGIPC : WRITE('NEG');
       SBIPC : WRITE('SUB');
       ODDPC : WRITE('ODD');
       MST0PC: WRITE('MARKP');
       MSTNPC: WRITE('MARKF #',BYTE:1);
       RETPC : WRITE('RETURN');
       CSPPC : STANDARDPROC;
       CAPPC : BEGIN WRITE('CAP $'); HEX(2) END;
       CUP1PC: WRITE('CUP1 #',BYTE:1);
       CUP2PC: WRITE('CUP2 #',BYTE:1);
       FIX21PC: WRITE('PUSH BYTE 0');
       CASEPC: CASESTATEMENT;
       MOVEPC: WRITE('MOVE',BYTE2:1);
       FORPC : WRITE('FOR #',BYTE2:1);
       GSSPC : WRITE('LOAD [J..I]');
       OTHERWISE WRITE('ILL ',OP)
       END;
     IF DOP<>CASEPC THEN WRITELN;
     END;

  FUNCTION QUESTION(ASK, DEFAULT: BOOLEAN): ANSWER;
  VAR C:CHAR;

  BEGIN 
    IF DEFAULT THEN C:='Y' ELSE C:='N';
    IF ASK THEN
      REPEAT
        READLN(C)
        UNTIL (C='Y') OR (C='N');
    IF C='Y' THEN QUESTION:=YES ELSE QUESTION:=NO
  END;

  PROCEDURE LISTVALUE;
  VAR I:INTEGER;
   RESPONSE: BOOLEAN;
  BEGIN 
    WRITELN('Value Part ',-VARSIZE);
    RESPONSE:=QUESTION(OPT=CHOICE,OPT=LIST)=YES;
    LOAD;
    WHILE VALUEPART=TRUE DO
      BEGIN
      IF RESPONSE THEN WRITELN('  Variable = ',VARADDR);
      LOAD;
      LAST:=P;
      P:=0;
      IF RESPONSE THEN
        WHILE P<LAST DO
          BEGIN WRITE('      ');
          IF (LAST-P)>20 THEN HEX(20) ELSE HEX(LAST-P);
          WRITELN
          END;
      END;
  END;

  PROCEDURE LISTPROCEDURE;
  BEGIN
    P:=0;
    WHILE P<>LAST DO 
      BEGIN WRITE(P,' ');
        OP:=BYTE;
        IF OP < 128 THEN PACOP ELSE FULLOP
      END
  END;


  BEGIN
  LOAD;
  IF VALUEPART THEN LISTVALUE;
  REPEAT
    WRITE('Procedure #',PROC:2,' ',NAME:8);
    IF EXTERNALPROCEDURE 
     THEN BEGIN WRITELN(' External'); LOAD END
     ELSE BEGIN LOAD;
      LAST:=P;
      WRITELN(' (',LAST:1,')');
      IF QUESTION(OPT=CHOICE,OPT=LIST)=YES
        THEN LISTPROCEDURE;
      END
    UNTIL ENDP;
  END;

PROCEDURE GETFILENAME(VAR FN:FILENAME; EX:EXTENSION);
  EXTERN GETFNAME;

PROCEDURE READOPTIONS;
  VAR C:CHAR;
  BEGIN
    REPEAT
      WRITE('OPTIONS H)EADERS, C)HOICE, L)IST:');
      READLN(C);
      UNTIL (C='H') OR (C='C') OR (C='L');
    IF C='H' THEN OPT:=HEADERS ELSE
      IF C='C' THEN OPT:=CHOICE ELSE
        OPT:=LIST;
  END;


BEGIN 
  ENDP:=FALSE;
  GETFILENAME(FN,XBIN);
  RESET(LGO,FN);
  READOPTIONS;
  LISTBINARY
END.
