  PROCEDURE CONSTANT(FSYS: SETOFSYS; VAR FSP: STP; VAR FVALU: VALU);
  TYPE SIGNS = (NONE,POS,NEG);
  VAR LSP: STP; LCP: CTP; SIGN: SIGNS;
      LVP: CSP; I: 2..STRGLGTH;
  BEGIN LSP:=NIL; FVALU.IVAL:=0;
    TEST2(CONSTBEGSYS,50,FSYS);
    IF SY IN CONSTBEGSYS THEN
      BEGIN
        IF SY=STRINGCONST THEN
          BEGIN
            IF LGTH=1 THEN LSP:=CHARPTR
            ELSE
              BEGIN
                NEW(LSP);
                LSP^.STYPE:=CHARPTR; LSP^.INXTYPE:=NIL;
                LSP^.SIZE:=STRINGSIZE(VAL.VALP); LSP^.FORM:=ARRAYS;
              END;
            FVALU:=VAL; INSYMBOL
          END
        ELSE
          BEGIN
            SIGN:=NONE;
            IF (SY=ADDOP) AND (OP IN [PLUS,MINUS]) THEN
              BEGIN IF OP=PLUS THEN SIGN:=POS ELSE SIGN:=NEG;
                INSYMBOL
              END;
            IF SY=IDENT THEN
              BEGIN SEARCHID([KONST],LCP);
                LSP:=LCP^.IDTYPE; FVALU:=LCP^.VALUES;
                IF SIGN<>NONE THEN
                  IF LSP=INTPTR THEN
                    BEGIN IF SIGN=NEG THEN FVALU.IVAL:=-FVALU.IVAL END
                    ELSE ERROR(105);
                INSYMBOL;
              END
            ELSE
              IF SY=INTCONST THEN
                BEGIN IF SIGN=NEG THEN VAL.IVAL:=-VAL.IVAL;
                  LSP:=INTPTR; FVALU:=VAL; INSYMBOL
                END
              ELSE
                  BEGIN ERROR(106); SKIP(FSYS) END
          END;
        TEST1(FSYS,6)
      END;
    FSP:=LSP
  END (* CONSTANT *);

  FUNCTION COMPTYPES(FSP1,FSP2: STP): BOOLEAN;
  (* DECIDE WHETHER STRUCTURES POINTED AT BY FSP1 AND FSP2 ARE
     COMPATIBLE *)
  BEGIN
    IF FSP1<>NIL THEN 
      IF FSP1^.FORM=SUBRANGE THEN FSP1:=FSP1^.STYPE;
    IF FSP2<>NIL THEN 
      IF FSP2^.FORM=SUBRANGE THEN FSP2:=FSP2^.STYPE;
    IF FSP1=FSP2 THEN COMPTYPES:=TRUE
    ELSE
      IF (FSP1<>NIL) AND (FSP2<>NIL) THEN
        IF FSP1^.FORM=FSP2^.FORM THEN
          CASE FSP1^.FORM OF
            SCALAR,RECORDS: COMPTYPES:=FALSE;
            SUBRANGE,POINTER,POWER:
              COMPTYPES:=COMPTYPES(FSP1^.STYPE,FSP2^.STYPE);
            ARRAYS:
              COMPTYPES:=COMPTYPES(FSP1^.STYPE,FSP2^.STYPE) AND
                (FSP1^.SIZE=FSP2^.SIZE)
          END
        ELSE (* FSP1^.FORM<>FSP2^.FORM *)
          COMPTYPES:=FALSE
      ELSE COMPTYPES:=TRUE
  END (* COMPTYPES *);

  FUNCTION COMPPARAMS(FSP1, FSP2: STP; VARPARM: BOOLEAN): BOOLEAN;
  (* DECIDE WHETHER THE STRUCTURES DEFINED BY FSP1 AND FSP2 ARE
     PARAMETER COMPATABLE. FSP1=FORMAL PARAM; FSP2=ACTUAL PARAM *)
  BEGIN (* COMPPARAMS *)
    IF FSP1=FSP2 THEN COMPPARAMS:=TRUE
    ELSE 
     IF (FSP1<>NIL) AND (FSP2<>NIL) THEN
      IF (FSP1^.FORM=FILES) AND (FSP2^.FORM=FILES) THEN
        COMPPARAMS:=FSP1^.STYPE=FSP2^.STYPE
      ELSE 
       IF VARPARM THEN COMPPARAMS:=FALSE
       ELSE COMPPARAMS:=COMPTYPES(FSP1,FSP2)
     ELSE COMPPARAMS:=TRUE
  END (* COMPPARAMS *);

  FUNCTION STRING(FSP: STP): BOOLEAN;
  BEGIN STRING:=FALSE;
    IF FSP<>NIL THEN
      IF FSP^.FORM=ARRAYS THEN
        IF COMPTYPES(FSP^.STYPE,CHARPTR) THEN STRING:=TRUE
  END (* STRING *);

  PROCEDURE TYP(FSYS: SETOFSYS; VAR FSP: STP; VAR FSIZE: ADDRRANGE);
  VAR LSP,LSP1,LSP2: STP; OLDTOP: DISPRANGE; LCP: CTP;
      LSIZE,DISPL: ADDRRANGE; LMIN,LMAX: INTEGER;

    PROCEDURE SIMPLETYPE(FSYS:SETOFSYS;VAR FSP:STP;VAR FSIZE:ADDRRANGE);
    VAR LSP,LSP1: STP; LCP,LCP1: CTP; TTOP: DISPRANGE;
        LCNT: INTEGER; LVALU: VALU;

      PROCEDURE SUBRANGS(FSP:STP; FVALU:VALU);
      BEGIN NEW(LSP);
      LSP^.FORM:=SUBRANGE; LSP^.STYPE:=FSP;
      LSP^.MIN :=FVALU;
      INTEST(DOTDOT,21);
      CONSTANT(FSYS,LSP1,LVALU);
      LSP^.MAX:=LVALU;
      IF (LVALU.IVAL>255) OR (LSP^.MIN.IVAL<0)
       THEN LSP^.SIZE:=INTSIZE ELSE LSP^.SIZE:=1;
      IF NOT COMPTYPES(FSP,LSP1) THEN ERROR(107)
       ELSE IF STRING(FSP) THEN 
        BEGIN ERROR(148); LSP^.STYPE:=NIL END;
      END (* SUBRANGES *);

    BEGIN FSIZE:=1;
      TEST2(SIMPTYPEBEGSYS,1,FSYS);
      IF SY IN SIMPTYPEBEGSYS THEN
        BEGIN
          IF SY=LPARENT THEN
            BEGIN TTOP:=TOP; TOP:=SAVETOP;
              NEW(LSP); LSP^.FORM:=SCALAR;
              LCP1:=NIL; LCNT:=0;
              REPEAT INSYMBOL;
                IF SY=IDENT THEN
                  BEGIN NEW(LCP); LCP^.NAME:=ID; LCP^.IDTYPE:=LSP;
                    LCP^.NEXT:=LCP1; LCP^.VALUES.IVAL:=LCNT;
                    LCP^.KLASS:=KONST;
                    ENTERID(LCP); LCNT:=LCNT+1; LCP1:=LCP; INSYMBOL
                  END
                ELSE ERROR(2);
                TEST1(FSYS+[COMMA,RPARENT],6);
              UNTIL SY<>COMMA;
              LSP^.FSTFLD:=LCP1; TOP:=TTOP;
              IF LCNT<257 THEN LSP^.SIZE:=1 ELSE LSP^.SIZE:=INTSIZE;
              INTEST(RPARENT,4)
            END
          ELSE
          IF SY=IDENT THEN
            BEGIN SEARCHID([TYPES,KONST],LCP);
              INSYMBOL;
              IF LCP^.KLASS=KONST 
              THEN SUBRANGS(LCP^.IDTYPE,LCP^.VALUES)
              ELSE LSP:=LCP^.IDTYPE
            END (* SY=IDENT *)
          ELSE
            BEGIN NEW(LSP); LSP^.FORM:=SUBRANGE;
              CONSTANT(FSYS+[DOTDOT],LSP1,LVALU);
              SUBRANGS(LSP1,LVALU)
            END;
          IF LSP<>NIL THEN
            IF LSP^.FORM=SUBRANGE THEN
              IF LSP^.MIN.IVAL>LSP^.MAX.IVAL THEN ERROR(102);
          FSP:=LSP;
          TEST1(FSYS,6)
        END
      ELSE FSP:=NIL;
      IF LSP<>NIL THEN FSIZE:=LSP^.SIZE
    END (* SIMPLETYPE *);

    PROCEDURE FIELDLIST(FSYS: SETOFSYS);
    VAR LCP,LCP1,NXT,NXT1: CTP; LSP,LSP3: STP;
      MINSIZE,MAXSIZE,LSIZE: ADDRRANGE;
      LVALU: VALU; I:INTEGER;
    BEGIN NXT1:=NIL; LSP:=NIL;
      TEST2([IDENT,CASESY],19,FSYS);
      WHILE SY=IDENT DO
        BEGIN NXT:=NXT1; I:=0;
          REPEAT
            IF SY=IDENT THEN
              BEGIN NEW(LCP);
                LCP^.NAME:=ID; LCP^.IDTYPE:=NIL; LCP^.NEXT:=NXT;
                LCP^.KLASS:=FIELD;
                NXT:=LCP; I:=I+1;
                ENTERID(LCP);
                INSYMBOL
              END
            ELSE ERROR(2);
            TEST2([COMMA,COLON],6,FSYS+[SEMICOLON,CASESY]);
            TEST:=SY<>COMMA;
            IF NOT TEST THEN INSYMBOL
          UNTIL TEST;
          INTEST(COLON,5);
          TYP(FSYS+[CASESY,SEMICOLON],LSP,LSIZE);
          DISPL:=LSIZE*I+DISPL;
          I:=DISPL-LSIZE;
          WHILE NXT<>NXT1 DO
            BEGIN
              NXT^.IDTYPE:=LSP; NXT^.VADDR:=I;
              NXT:=NXT^.NEXT; I:=I-LSIZE
            END;
          NXT1:=LCP;
          IF SY=SEMICOLON THEN
            BEGIN INSYMBOL;
              TEST2([IDENT,CASESY],19,FSYS)
            END
        END (* WHILE *);
      NXT:=NIL;
      WHILE NXT1<>NIL DO
        BEGIN
          LCP:=NXT1^.NEXT; NXT1^.NEXT:=NXT; NXT:=NXT1; NXT1:=LCP
        END;
      IF SY=CASESY THEN
        BEGIN INSYMBOL;
          IF SY=IDENT THEN
            BEGIN PRTERR:=FALSE; SEARCHID([TYPES],LCP1);
              PRTERR:=TRUE;
              IF LCP1=NIL THEN
                BEGIN NEW(LCP); LCP^.NAME:=ID; LCP^.IDTYPE:=NIL;
                  LCP^.KLASS:=FIELD; LCP^.NEXT:=NIL;
                  LCP^.VADDR:=DISPL;
                  ENTERID(LCP); INSYMBOL;
                  INTEST(COLON,5);
                  IF SY=IDENT THEN
                    BEGIN SEARCHID([TYPES],LCP1);
                      LSP1:=LCP1^.IDTYPE;
                      IF LSP1<>NIL THEN
                        BEGIN DISPL:=DISPL+LSP1^.SIZE;
                          IF (LSP1^.FORM<=SUBRANGE) OR STRING(LSP1) THEN
                            BEGIN
                            (*IF LSP1=REALPTR THEN ERROR(109)
                              ELSE*)IF STRING(LSP1) THEN ERROR(399);
                              LCP^.IDTYPE:=LSP1
                            END
                          ELSE ERROR(110)
                        END;
                      INSYMBOL
                    END
                  ELSE BEGIN ERROR(2); SKIP(FSYS+[OFSY,LPARENT]) END
                END
              ELSE BEGIN INSYMBOL; LSP1:=LCP1^.IDTYPE END
            END
          ELSE BEGIN ERROR(2); SKIP(FSYS+[OFSY,LPARENT]) END;
          INTEST(OFSY,8);
          MINSIZE:=DISPL; MAXSIZE:=DISPL;
          REPEAT LSP2:=NIL;
            REPEAT CONSTANT(FSYS+[COMMA,COLON,LPARENT],LSP3,LVALU);
              IF NOT COMPTYPES(LSP1,LSP3) THEN ERROR(111);
              TEST:=SY<>COMMA;
              IF NOT TEST THEN INSYMBOL
            UNTIL TEST;
            INTEST(COLON,5); INTEST(LPARENT,9);
            FIELDLIST(FSYS+[RPARENT,SEMICOLON]);
            IF DISPL>MAXSIZE THEN MAXSIZE:=DISPL;
            IF SY=RPARENT THEN
              BEGIN INSYMBOL;
                TEST1(FSYS+[SEMICOLON],6)
              END
            ELSE ERROR(4);
            TEST:=SY<>SEMICOLON;
            IF NOT TEST THEN
              BEGIN DISPL:=MINSIZE; INSYMBOL END
          UNTIL TEST;
          DISPL:=MAXSIZE
        END
    END (* FIELDLIST *);

BEGIN (* TYP *)
  TEST2(TYPEBEGSYS,10,FSYS);
  IF SY IN TYPEBEGSYS THEN
    BEGIN
      IF SY IN SIMPTYPEBEGSYS THEN SIMPLETYPE(FSYS,FSP,FSIZE)
      ELSE
(* ^ *) IF SY=ARROW THEN
          BEGIN NEW(LSP); FSP:=LSP;
            LSP^.STYPE:=NIL; LSP^.SIZE:=PTRSIZE; LSP^.FORM:=POINTER;
            INSYMBOL;
            IF SY=IDENT THEN
              BEGIN PRTERR:=FALSE; (* NO ERROR IF NOT FOUND *)
                SEARCHID([TYPES],LCP); PRTERR:=TRUE;
                IF LCP=NIL THEN (* FORWARD REF. TYPE ID *)
                  BEGIN NEW(LCP);
                    LCP^.NAME:=ID; LCP^.IDTYPE:=LSP;
                    LCP^.NEXT:=FWPTR; LCP^.KLASS:=TYPES;
                    FWPTR:=LCP
                  END
                ELSE
                  BEGIN
                    IF LCP^.IDTYPE<>NIL THEN
                      LSP^.STYPE:=LCP^.IDTYPE
                  END;
                INSYMBOL;
              END
            ELSE ERROR(2);
          END
        ELSE
          BEGIN
            IF SY=PACKEDSY THEN
              BEGIN INSYMBOL;
                TEST2(TYPEDELS,10,FSYS)
              END;
            CASE SY OF
(* ARRAY *)   ARRAYSY:
                BEGIN INSYMBOL;
                  INTEST(LBRACK,11);
                  LSP1:=NIL;
                  REPEAT NEW(LSP);
                    LSP^.STYPE:=LSP1; LSP^.INXTYPE:=NIL;
                    LSP^.FORM:=ARRAYS;
                    LSP1:=LSP;
                    SIMPLETYPE(FSYS+[COMMA,RBRACK,OFSY],LSP2,LSIZE);
                    LSP1^.SIZE:=LSIZE;
                    IF LSP2<>NIL THEN
                      IF LSP2^.FORM<=SUBRANGE THEN
                        BEGIN
                          IF LSP2=INTPTR THEN
                            BEGIN ERROR(149); LSP2:=NIL END;
                          LSP^.INXTYPE:=LSP2
                        END
                      ELSE BEGIN ERROR(113); LSP2:=NIL END;
                    TEST:=SY<>COMMA;
                    IF NOT TEST THEN INSYMBOL
                  UNTIL TEST;
                  INTEST(RBRACK,12); INTEST(OFSY,8);
                  TYP(FSYS,LSP,LSIZE);
                  REPEAT
                    LSP2:=LSP1^.STYPE; LSP1^.STYPE:=LSP;
                    IF LSP1^.INXTYPE<>NIL THEN
                      BEGIN GETBOUNDS(LSP1^.INXTYPE,LMIN,LMAX);
                        LSIZE:=LSIZE*(LMAX-LMIN+1);
                        LSP1^.SIZE:=LSIZE
                      END;
                    LSP:=LSP1; LSP1:=LSP2
                  UNTIL LSP1=NIL
                END;
(* RECORD *)  RECORDSY:
                BEGIN INSYMBOL;
                  OLDTOP:=TOP;
                  IF TOP<DISPLIMIT THEN
                    BEGIN TOP:=TOP+1;
                      DISPLAY[TOP]:=NIL
                    END
                  ELSE ERROR(250);
                  DISPL:=0;
                  FIELDLIST(FSYS-[SEMICOLON]+[ENDSY]);
                  NEW(LSP);
                  LSP^.FSTFLD:=DISPLAY[TOP];
                  LSP^.SIZE:=DISPL;
                  LSP^.FORM:=RECORDS;
                  TOP:=OLDTOP;
                  INTEST(ENDSY,13)
                END;
(* SET *)     SETSY:
                BEGIN INSYMBOL;
                  INTEST(OFSY,8);
                  SIMPLETYPE(FSYS,LSP1,LSIZE);
                  IF LSP1<>NIL THEN
                    IF LSP1^.FORM>SUBRANGE THEN
                      BEGIN ERROR(115); LSP1:=NIL END;
                  NEW(LSP);
                  LSP^.STYPE:=LSP1; LSP^.SIZE:=SETSIZE;
                  LSP^.FORM:=POWER
                END;
              FILESY:
                BEGIN INSYMBOL;
                  INTEST(OFSY,8);
                  NEW(LSP); LSP^.FORM:=FILES;
                  TYP(FSYS,LSP1,LSIZE);
                  LSP^.SIZE:=FILESIZE+LSIZE;
                  LSP^.STYPE:=LSP1
                END
            END;
            FSP:=LSP
          END;
      TEST1(FSYS,6)
    END
  ELSE FSP:=NIL;
  IF FSP=NIL THEN FSIZE:=1 ELSE FSIZE:=FSP^.SIZE
END (* TYP *);

PROCEDURE CONSTDECLARATION;
VAR LCP: CTP; LSP: STP; LVALU: VALU;
BEGIN
  TEST2([IDENT],2,FSYS);
  WHILE SY=IDENT DO
    BEGIN NEW(LCP);
      LCP^.NAME:=ID; LCP^.IDTYPE:=NIL; LCP^.NEXT:=NIL;
      LCP^.KLASS:=KONST;
      INSYMBOL;
      IF (SY=RELOP) AND (OP=EQOP) THEN INSYMBOL ELSE ERROR(16);
      CONSTANT(FSYS+[SEMICOLON],LSP,LVALU);
      ENTERID(LCP);
      LCP^.IDTYPE:=LSP; LCP^.VALUES:=LVALU;
      IF SY=SEMICOLON THEN
        BEGIN INSYMBOL;
          TEST1(FSYS+[IDENT],6)
        END
      ELSE ERROR(14)
    END
END (* CONSTDECLARATION *);

PROCEDURE TYPEDECLARATION;
VAR LCP,LCP1,LCP2: CTP; LSP: STP; LSIZE: ADDRRANGE;
BEGIN
  TEST2([IDENT],2,FSYS);
  WHILE SY=IDENT DO
    BEGIN NEW(LCP);
      LCP^.NAME:=ID; LCP^.IDTYPE:=NIL; LCP^.KLASS:=TYPES;
      INSYMBOL;
      IF (SY=RELOP) AND (OP=EQOP) THEN INSYMBOL ELSE ERROR(16);
      TYP(FSYS+[SEMICOLON],LSP,LSIZE);
      ENTERID(LCP);
      LCP^.IDTYPE:=LSP;
      (* HAS ANY FORWARD REF. BEEN SATISFIED *)
      LCP1:=FWPTR;
      WHILE LCP1<>NIL DO
        BEGIN
          IF LCP1^.NAME=LCP^.NAME THEN
            BEGIN LCP1^.IDTYPE^.STYPE:=LCP^.IDTYPE;
              IF LCP1<>FWPTR THEN
                LCP2^.NEXT:=LCP1^.NEXT
              ELSE FWPTR:=LCP1^.NEXT;
            END;
          LCP2:=LCP1; LCP1:=LCP1^.NEXT
        END;
      IF SY=SEMICOLON THEN
        BEGIN INSYMBOL;
          TEST1(FSYS+[IDENT],6)
        END
      ELSE ERROR(14)
    END;
  IF FWPTR<>NIL THEN
    BEGIN ERROR(117); WRITELN;
      REPEAT WRITELN(' TYPE-ID ',FWPTR^.NAME);
        FWPTR:=FWPTR^.NEXT
      UNTIL FWPTR=NIL;
    END
END (* TYPEDECLARATION *);

PROCEDURE VARDECLARATION;
VAR LCP,NXT: CTP; LSP: STP; LSIZE: ADDRRANGE;
BEGIN NXT:=NIL;
  REPEAT
  REPEAT
    IF SY=IDENT THEN
      BEGIN NEW(LCP);
        LCP^.NAME:=ID; LCP^.NEXT:=NXT; LCP^.KLASS:=VARS;
        LCP^.IDTYPE:=NIL; LCP^.VKIND:=ACTUAL; LCP^.VLEV:=LEVEL;
        ENTERID(LCP);
        NXT:=LCP;
        INSYMBOL
      END
    ELSE ERROR(2);
    TEST2(FSYS+TYPEDELS+[COMMA,COLON],6,[SEMICOLON]);
    TEST:=SY<>COMMA;
    IF NOT TEST THEN INSYMBOL;
  UNTIL TEST;
  INTEST(COLON,5);
  TYP(FSYS+[SEMICOLON]+TYPEDELS,LSP,LSIZE);
  WHILE NXT<>NIL DO
    BEGIN NXT^.IDTYPE:=LSP; LC:=LC-LSIZE;
      NXT^.VADDR:=LC; NXT:=NXT^.NEXT
    END;
  IF SY=SEMICOLON THEN
    BEGIN INSYMBOL;
      TEST1(FSYS+[IDENT],6)
    END
  ELSE ERROR(14)
  UNTIL (SY<>IDENT) AND NOT(SY IN TYPEDELS);
  IF FWPTR<>NIL THEN
    BEGIN ERROR(117); WRITELN;
      REPEAT WRITELN(' TYPE-ID ',FWPTR^.NAME);
        FWPTR:=FWPTR^.NEXT
      UNTIL FWPTR=NIL;
    END
END (* VARDECLARATION *);

PROCEDURE PROCDECLARATION(FSY: SYMBOL);
VAR OLDLEV: 0..MAXLEVEL; LSY: SYMBOL; LCP,LCP1: CTP; LSP: STP;
    FORW: BOOLEAN; OLDTOP: DISPRANGE;
    LLC,LCM: ADDRRANGE; MARKP: ^CHAR;

  PROCEDURE PARAMETERLIST(FSY: SETOFSYS; VAR FPAR: CTP);
  VAR LCP,LCP1,LCP2,LCP3: CTP; LSP: STP; LKIND: IDKIND;
    LLC,LEN: ADDRRANGE; COUNT,OFFSET: INTEGER;
  BEGIN LCP1:=NIL;
    TEST1(FSY+[LPARENT],7);
    IF SY=LPARENT THEN
      BEGIN IF FORW THEN ERROR(119);
        INSYMBOL;
        IF NOT(SY IN [IDENT,VARSY]) THEN
          BEGIN ERROR(7); SKIP(FSYS+[IDENT,RPARENT]) END;
        WHILE SY IN [IDENT,VARSY] DO
          BEGIN
            IF SY=VARSY THEN
              BEGIN LKIND:=FORMAL; INSYMBOL END
            ELSE LKIND:=ACTUAL;
            LCP2:=NIL;
            COUNT:=0;
            REPEAT
              IF SY=IDENT THEN
                BEGIN NEW(LCP);
                  LCP^.NAME:=ID; LCP^.IDTYPE:=NIL;
                  LCP^.KLASS:=VARS; LCP^.VKIND:=LKIND;
                  LCP^.NEXT:=LCP2; LCP^.VLEV:=LEVEL;
                  ENTERID(LCP);
                  LCP2:=LCP; COUNT:=COUNT+1;
                  INSYMBOL;
                END;
              IF NOT(SY IN [COMMA,COLON]+FSYS) THEN
                BEGIN ERROR(7);
                  SKIP(FSYS+[COMMA,SEMICOLON,RPARENT])
                END;
              TEST:=SY<>COMMA;
              IF NOT TEST THEN INSYMBOL
            UNTIL TEST;
            IF SY=COLON THEN
              BEGIN INSYMBOL;
                IF SY=IDENT THEN
                  BEGIN SEARCHID([TYPES],LCP);
                    LSP:=LCP^.IDTYPE;
                    LCP3:=LCP2;
                    OFFSET:=0; LEN:=PTRSIZE;
                    IF (LKIND=ACTUAL) AND (LSP^.FORM<ARRAYS) THEN
                      IF LSP^.SIZE=1 THEN OFFSET:=1
                      ELSE LEN:=LSP^.SIZE;
                    LC:=LC-COUNT*LEN;
                    LLC:=LC;
                    WHILE LCP2<>NIL DO
                      BEGIN LCP:=LCP2;
                        LCP2^.IDTYPE:=LSP; LCP2^.VADDR:=LLC+OFFSET;
                        LLC:=LLC+LEN; LCP2:=LCP2^.NEXT
                      END;
                    LCP^.NEXT:=LCP1; LCP1:=LCP3;
                    INSYMBOL
                  END
                ELSE ERROR(2);
                TEST1(FSYS+[SEMICOLON,RPARENT],7)
              END
            ELSE ERROR(5);
            IF SY=SEMICOLON THEN
              BEGIN INSYMBOL;
                IF NOT(SY IN FSYS+[IDENT,VARSY]) THEN
                  BEGIN ERROR(7); SKIP(FSYS+[IDENT,RPARENT]) END
              END
          END (* WHILE *);
        IF SY=RPARENT THEN
          BEGIN INSYMBOL;
            TEST1(FSY+FSYS,6)
          END
        ELSE ERROR(4);
        LCP3:=NIL;
        (* REVERSE POINTERS AND RESERVE LOCAL CELLS FOR COPIES OF
           MULTIPLE VALUES *)
        WHILE LCP1<>NIL DO
          BEGIN LCP2:=LCP1^.NEXT; LCP1^.NEXT:=LCP3;
            IF LCP1^.KLASS=VARS THEN
              IF LCP1^.IDTYPE<>NIL THEN
                IF (LCP1^.VKIND=ACTUAL)AND(LCP1^.IDTYPE^.FORM>POWER)
                THEN
                  BEGIN LC:=LC-LCP1^.IDTYPE^.SIZE; LCP1^.VADDR:=LC
                  END;
            LCP3:=LCP1; LCP1:=LCP2
          END;
        FPAR:=LCP3
      END
    ELSE FPAR:=NIL
  END (* PARAMETERLIST *);

BEGIN (* PROCDECLARATION *)
  LLC:=LC; LC:=-LCAFTERMARKSTACK;
  IF SY=IDENT THEN
    BEGIN SEARCHSECTION(DISPLAY[TOP],LCP); (* DECIDE IF FORW *)
      IF LCP<>NIL THEN
        BEGIN
          IF LCP^.KLASS=PROC THEN
            FORW:=LCP^.FORWDECL AND(FSY=PROCSY)
          ELSE
            IF LCP^.KLASS=FUNC THEN
              FORW:=LCP^.FORWDECL AND(FSY=FUNCSY)
            ELSE FORW:=FALSE;
          IF NOT FORW THEN ERROR(160)
        END
      ELSE FORW:=FALSE;
      IF NOT FORW THEN
        BEGIN
          NEW(LCP);
          LCP^.NAME:=ID; LCP^.IDTYPE:=NIL;
          LCP^.PFLEV:=LEVEL; LCP^.PFNAME:=NPROC; NPROC:=NPROC+1;
          LCP^.PFDECKIND:=DECLARED;
          IF FSY=PROCSY THEN LCP^.KLASS:=PROC
          ELSE LCP^.KLASS:=FUNC;
          ENTERID(LCP)
        END
      ELSE
        BEGIN LCP1:=LCP^.NEXT;
          WHILE LCP1<>NIL DO
            BEGIN
              IF LCP1^.KLASS=VARS THEN
                IF LCP1^.IDTYPE<>NIL THEN
                  BEGIN LCM:=LCP1^.VADDR;
                    IF LCM<LC THEN LC:=LCM
                  END;
              LCP1:=LCP1^.NEXT
            END
        END;
      INSYMBOL
    END
  ELSE ERROR(2);
  OLDLEV:=LEVEL; OLDTOP:=TOP;
  IF LEVEL<MAXLEVEL THEN LEVEL:=LEVEL+1 ELSE ERROR(251);
  IF TOP<DISPLIMIT THEN
    BEGIN TOP:=TOP+1; SAVETOP:=TOP;
      IF FORW THEN DISPLAY[TOP]:=LCP^.NEXT
      ELSE DISPLAY[TOP]:=NIL
    END
  ELSE ERROR(250);
  IF FSY=PROCSY THEN
    BEGIN PARAMETERLIST([SEMICOLON],LCP1);
      IF NOT FORW THEN LCP^.NEXT:=LCP1
    END
  ELSE
    BEGIN PARAMETERLIST([SEMICOLON,COLON],LCP1);
      IF NOT FORW THEN LCP^.NEXT:=LCP1;
      IF SY=COLON THEN
        BEGIN INSYMBOL;
          IF SY=IDENT THEN
            BEGIN IF FORW THEN ERROR(122);
              SEARCHID([TYPES],LCP1);
              LSP:=LCP1^.IDTYPE;
              LCP^.IDTYPE:=LSP;
              IF LSP<>NIL THEN
                IF LSP^.FORM>POWER THEN
                  BEGIN ERROR(120); LCP^.IDTYPE:=NIL END;
              INSYMBOL
            END
          ELSE BEGIN ERROR(2); SKIP(FSYS+[SEMICOLON]) END
        END
      ELSE
        IF NOT FORW THEN ERROR(123)
    END;
  INTEST(SEMICOLON,14);
  IF SY=FORWARDSY THEN
    BEGIN
      IF FORW THEN ERROR(161)
      ELSE
        LCP^.FORWDECL:=TRUE;
      INSYMBOL;
      INTEST(SEMICOLON,14);
      TEST1(FSYS,6)
    END
  ELSE
    IF SY=EXTERNSY THEN
      BEGIN
        IF FORW THEN ERROR(161);
        INSYMBOL; WRITEOUT;
        CODEBUF[0]:=CHR(8); CODEBUF[1]:=CHR(LCP^.PFNAME);
        PUTS(LGO,CODEBUF[0],2);
        IF SY=IDENT THEN
          BEGIN PUTS(LGO,ID[1],8); INSYMBOL END
        ELSE PUTS(LGO,LCP^.NAME[1],8);
        INTEST(SEMICOLON,14);
        TEST1(FSYS,6)
      END
    ELSE
      BEGIN LCP^.FORWDECL:=FALSE; NEW(MARKP);
        REPEAT BLOCK(FSYS,SEMICOLON,LCP);
          IF SY=SEMICOLON THEN
            BEGIN INSYMBOL;
              IF NOT(SY IN [BEGINSY,PROCSY,FUNCSY]) THEN
                BEGIN ERROR(6); SKIP(FSYS) END
            END
          ELSE ERROR(14)
        UNTIL SY IN [BEGINSY,PROCSY,FUNCSY];
        RELEASE(MARKP)
      END;
  LEVEL:=OLDLEV; TOP:=OLDTOP; LC:=LLC;
END (* PROCDECLARATION *);

