PROCEDURE BODY(FSYS: SETOFSYS);
VAR I,ENTNAME,SEGSIZE: INTEGER;
    LCMAX,LLC1: ADDRRANGE; LCP: CTP;

  PROCEDURE LDAGEN(LEV: INTEGER; DPLMT: ADDRRANGE);
  BEGIN
    IF DPLMT>-128 THEN
      BEGIN BYTEGEN(LDASPC+LEV); BYTEGEN(DPLMT) END
    ELSE
      BEGIN BYTEGEN(LDAPC+LEV); ADDRGEN(DPLMT) END
  END (* LDAGEN *);

  PROCEDURE LODGEN(LEV: INTEGER; FATTR: ATTR);
  BEGIN
    IF (FATTR.TYPTR^.SIZE<=2)AND(FATTR.DPLMT>-128) THEN
      BEGIN BYTEGEN(LDVPC+16*GATTR.TYPTR^.SIZE+LEV);
        BYTEGEN(FATTR.DPLMT)
      END
    ELSE
      BEGIN LDAGEN(LEV,FATTR.DPLMT);
        CASE FATTR.TYPTR^.SIZE OF
          1: OPGEN(LDIBPC);
          2: OPGEN(LDIWPC);
          8: OPGEN(LDISPC)
        END
      END
  END (* LODGEN *);

  PROCEDURE CONDGEN(PC: PCODES; LOP: OPERATOR);
  BEGIN 
    CASE LOP OF
     LTOP,GEOP: OPGEN(PRED(PC));
     EQOP,NEOP: OPGEN(PC);
     LEOP,GTOP: OPGEN(SUCC(PC))
     END;
  END (* CONDGEN *);

  PROCEDURE LDCIGEN(VAL: INTEGER);
  BEGIN
    IF (VAL<16) AND (VAL>=0) THEN BYTEGEN(VAL)
    ELSE
      IF VAL<0 THEN
        BEGIN OPGEN(LNCPC); ADDRGEN(-VAL) END
      ELSE
        BEGIN OPGEN(LDCPC); ADDRGEN(VAL) END
  END (* LDCIGEN *);

  PROCEDURE LDCS(S: INTSET);
  VAR I,N: INTEGER; B: BOOLEAN;
    D:DATAREC;
  BEGIN B:=FALSE;
    N:=CARD(S);
    IF N=0 THEN OPGEN(LNSPC) (* LOAD EMPTY SET *)
    ELSE
      IF N<4 THEN
        FOR I:=0 TO SETMAX DO
          IF I IN S THEN
            BEGIN LDCIGEN(I); OPGEN(SGSPC);
              IF B THEN OPGEN(UNIPC);
              B:=TRUE
            END
          ELSE
      ELSE
        BEGIN OPGEN(LDCSPC);
          D.S:=S;
          FOR I:=1 TO SETSIZE DO
            BYTEGEN(ORD(D.A[I]))
        END
  END (* LDCS *);

  PROCEDURE CSPGEN(P: CSPCODES);
  BEGIN
    OPGEN(CSPPC); BYTEGEN(ORD(P))
  END (* CSPGEN *);

  PROCEDURE GENINC(INC: INTEGER);
  BEGIN
    IF INC<>0 THEN
      IF INC=1 THEN OPGEN(INC1PC)
      ELSE
        IF INC=-1 THEN OPGEN(DEC1PC)
        ELSE
          IF INC>0 THEN
            BEGIN OPGEN(INCPC); ADDRGEN(INC) END
          ELSE
            BEGIN OPGEN(DECPC); ADDRGEN(-INC) END
  END (* GENINC *);

  PROCEDURE LOAD;
  BEGIN
    IF GATTR.TYPTR<>NIL THEN
      BEGIN
        IF GATTR.KIND=CST THEN
          IF (GATTR.TYPTR^.FORM=SCALAR) THEN LDCIGEN(GATTR.CVAL.IVAL)
          ELSE
          IF GATTR.TYPTR=NILPTR THEN BYTEGEN(0)
            ELSE LDCS(GATTR.CVAL.VALP^.PVAL)
        ELSE
          IF GATTR.KIND=VARBL THEN
            IF GATTR.ACCESS=DRCT THEN
              LODGEN(GATTR.LEVEL,GATTR)
            ELSE
              BEGIN
                GENINC(GATTR.DPLMT);
                CASE GATTR.TYPTR^.SIZE OF
                  1: OPGEN(LDIBPC);
                  2: OPGEN(LDIWPC);
                  8: OPGEN(LDISPC)
                END
              END;
        GATTR.KIND:=EXPR
      END
  END (* LOAD *);

  PROCEDURE STORE(FATTR: ATTR);
  VAR SIZE: INTEGER;
  BEGIN 
    IF FATTR.TYPTR<>NIL THEN
      BEGIN SIZE:=FATTR.TYPTR^.SIZE;
        IF FATTR.ACCESS=DRCT THEN
          IF (SIZE<=2) AND (FATTR.DPLMT>-128) THEN
            BEGIN BYTEGEN(STVPC+16*SIZE+FATTR.LEVEL);
              BYTEGEN(FATTR.DPLMT); SIZE:=0
            END
          ELSE ERROR(400)
        ELSE
          IF FATTR.DPLMT<>0 THEN ERROR(400);
        CASE SIZE OF
          0: (* NO ACTION *);
          1: OPGEN(STIBPC);
          2: OPGEN(STIWPC);
          8: OPGEN(STISPC)
          END
      END
  END (* STORE *);

  PROCEDURE LOADADDRESS;
  VAR LVP: CSP; I: INTEGER;
  BEGIN
    IF GATTR.TYPTR<>NIL THEN
      BEGIN
        IF GATTR.KIND=CST THEN
          IF STRING(GATTR.TYPTR) THEN
            BEGIN OPGEN(LCAPC);
              BYTEGEN(STRINGSIZE(GATTR.CVAL.VALP));
              LVP:=GATTR.CVAL.VALP;
              REPEAT
                FOR I:=1 TO LVP^.SLGTH DO
                  BYTEGEN(LVP^.SVAL[I]);
                LVP:=LVP^.SPTR
              UNTIL LVP=NIL
            END
          ELSE ERROR(400)
        ELSE
          IF GATTR.KIND=VARBL THEN
            IF GATTR.ACCESS=DRCT THEN
              LDAGEN(GATTR.LEVEL,GATTR.DPLMT)
            ELSE GENINC(GATTR.DPLMT)
          ELSE ERROR(400);
        GATTR.KIND:=VARBL; GATTR.ACCESS:=INDRCT; GATTR.DPLMT:=0
      END
  END (* LOADADDRESS *);

  PROCEDURE GENFJP(FADDR: INTEGER);
  BEGIN LOAD;
    IF GATTR.TYPTR<>NIL THEN
      IF GATTR.TYPTR<>BOOLPTR THEN ERROR(144);
    OPGEN(FJPC); ADDRGEN(FADDR)
  END (* GENFJP *);

  PROCEDURE GENCUP(FP1,FP2: INTEGER);
  BEGIN
    IF PFCTTEST THEN
      BEGIN LDCIGEN(FP1); OPGEN(CUP2PC) END
    ELSE OPGEN(CUP1PC);
    BYTEGEN(FP2)
  END (* GENCUP *);

  PROCEDURE STATEMENT(FSYS: SETOFSYS);
  VAR LCP: CTP; LSYM: SYMBOL;

 (*$ICOMP4.PAS -- INCLUDE EXPRESSION *)

PROCEDURE ASSIGNMENT(FCP: CTP);
VAR LATTR: ATTR;
BEGIN SELECTOR(FSYS+[BECOMES],FCP);
  IF SY=BECOMES THEN
    BEGIN
      IF GATTR.TYPTR<>NIL THEN
        IF (GATTR.ACCESS<>DRCT) OR (GATTR.TYPTR^.FORM>=POWER) OR
           (GATTR.DPLMT<=-128) THEN LOADADDRESS;
      LATTR:=GATTR;
      INSYMBOL; EXPRESSION(FSYS);
      IF GATTR.TYPTR<>NIL THEN
        IF GATTR.TYPTR^.FORM<=POWER THEN LOAD
        ELSE LOADADDRESS;
      IF (LATTR.TYPTR<>NIL) AND (GATTR.TYPTR<>NIL) THEN
        BEGIN
          IF COMPTYPES(LATTR.TYPTR,GATTR.TYPTR) THEN
            IF LATTR.TYPTR^.FORM IN [ARRAYS,RECORDS] THEN
              BEGIN OPGEN(MOVEPC); ADDRGEN(LATTR.TYPTR^.SIZE) END
            ELSE
             IF LATTR.TYPTR^.FORM=FILES THEN ERROR(146)
               ELSE STORE(LATTR)
          ELSE ERROR(129)
        END
    END (* SY=BECOMES *)
  ELSE ERROR(51)
END (* ASSIGNMENT *);

PROCEDURE COMPOUNDSTATEMENT;
BEGIN
  REPEAT
    REPEAT STATEMENT(FSYS+[SEMICOLON,ENDSY])
    UNTIL NOT(SY IN STATBEGSYS);
    TEST:=SY<>SEMICOLON;
    IF NOT TEST THEN INSYMBOL
  UNTIL TEST;
  INTEST(ENDSY,13)
END (* COMPOUNDSTATEMENT *);

PROCEDURE IFSTATEMENT;
VAR ICIX1,ICIX2: INTEGER;
BEGIN EXPRESSION(FSYS+[THENSY]);
  GENFJP(0); ICIX1:=IC+ICN-2;
  INTEST(THENSY,52);
  STATEMENT(FSYS+[ELSESY]);
  IF SY=ELSESY THEN
    BEGIN ICIX2:=IC+ICN; GENUJPENT(UJPC,0);
      PLANTADDR(ICIX1,IC+ICN);
      INSYMBOL; STATEMENT(FSYS);
      PLANTADDR(ICIX2+1,IC+ICN);
    END
  ELSE PLANTADDR(ICIX1,IC+ICN)
END (* IFSTATEMENT *);

PROCEDURE CASESTATEMENT;
TYPE CIP=^CASEINFO;
  CASEINFO=PACKED RECORD NEXT: CIP;
             CSSTART,CSLAB: INTEGER
           END;
VAR LSP,LSP1: STP; FSTPTR,LPT1,LPT2,LPT3: CIP; LVAL: VALU;
    LCIX,LCIX1,LMIN,LMAX: INTEGER;
BEGIN EXPRESSION(FSYS+[OFSY,COMMA,COLON]); LOAD;
  LCIX:=IC+ICN; GENUJPENT(UJPC,0); GENUJPENT(UJPC,0);
  LSP:=GATTR.TYPTR;
  IF LSP<>NIL THEN
    IF LSP^.FORM>SUBRANGE THEN
      BEGIN ERROR(144); LSP:=NIL END;
  INTEST(OFSY,8);
  FSTPTR:=NIL;
  REPEAT LPT3:=NIL; LCIX1:=IC+ICN;
    REPEAT CONSTANT(FSYS+[COMMA,COLON],LSP1,LVAL);
      IF LSP1<>NIL THEN
        IF COMPTYPES(LSP,LSP1) THEN
          BEGIN LPT1:=FSTPTR; LPT2:=NIL; TEST:=TRUE;
            WHILE (LPT1<>NIL) AND TEST DO
              IF LPT1^.CSLAB<=LVAL.IVAL THEN
                BEGIN IF LPT1^.CSLAB=LVAL.IVAL THEN ERROR(156);
                  TEST:=FALSE
                END
              ELSE BEGIN LPT2:=LPT1; LPT1:=LPT1^.NEXT END;
            NEW(LPT3); LPT3^.NEXT:=LPT1; LPT3^.CSLAB:=LVAL.IVAL;
            LPT3^.CSSTART:=LCIX1;
            IF LPT2=NIL THEN FSTPTR:=LPT3
            ELSE LPT2^.NEXT:=LPT3
          END
        ELSE ERROR(147);
      TEST:=SY<>COMMA;
      IF NOT TEST THEN INSYMBOL;
    UNTIL TEST;
    INTEST(COLON,5);
    REPEAT STATEMENT(FSYS+[SEMICOLON,OTHRWZSY])
    UNTIL NOT(SY IN STATBEGSYS);
    IF LPT3<>NIL THEN GENUJPENT(UJPC,LCIX+3);
    TEST:=SY<>SEMICOLON;
    IF NOT TEST THEN INSYMBOL;
  UNTIL TEST OR (SY=ENDSY) OR (SY=OTHRWZSY);
  PLANTADDR(LCIX+1,IC+ICN);
  IF FSTPTR<>NIL THEN
    BEGIN LMAX:=FSTPTR^.CSLAB; LPT1:=FSTPTR; FSTPTR:=NIL;
      (* REVERSE POINTERS *)
      REPEAT LPT2:=LPT1^.NEXT; LPT1^.NEXT:=FSTPTR;
        FSTPTR:=LPT1; LPT1:=LPT2
      UNTIL LPT1=NIL;
      LMIN:=FSTPTR^.CSLAB;
      OPGEN(CASEPC); ADDRGEN(LMIN); ADDRGEN(LMAX);
      LCIX1:=IC+ICN; ADDRGEN(0);
      REPEAT
        WHILE FSTPTR^.CSLAB>LMIN DO
          BEGIN ADDRGEN(0); LMIN:=LMIN+1 END;
        ADDRGEN(FSTPTR^.CSSTART);
        FSTPTR:=FSTPTR^.NEXT; LMIN:=LMIN+1
      UNTIL FSTPTR=NIL
    END
  ELSE ERROR(157);
  IF SY=OTHRWZSY THEN
    BEGIN INSYMBOL; PLANTADDR(LCIX1,IC+ICN);
      COMPOUNDSTATEMENT;
      GENUJPENT(UJPC,LCIX+3)
    END
   ELSE INTEST(ENDSY,13);
  PLANTADDR(LCIX+4,IC+ICN)
END (* CASESTATEMENT *);

PROCEDURE REPEATSTATEMENT;
VAR LADDR: INTEGER;
BEGIN LADDR:=IC+ICN;
  REPEAT
    REPEAT STATEMENT(FSYS+[SEMICOLON,UNTILSY])
    UNTIL NOT(SY IN STATBEGSYS);
    TEST:=SY<>SEMICOLON;
    IF NOT TEST THEN INSYMBOL
  UNTIL TEST;
  IF SY=UNTILSY THEN
    BEGIN INSYMBOL; EXPRESSION(FSYS); GENFJP(LADDR)
    END
  ELSE ERROR(53)
END (* REPEATSTATEMENT *);

PROCEDURE WHILESTATEMENT;
VAR LADDR,LCIX: INTEGER;
BEGIN LADDR:=IC+ICN;
  EXPRESSION(FSYS+[DOSY]); GENFJP(0); LCIX:=IC+ICN;
  INTEST(DOSY,54);
  STATEMENT(FSYS); GENUJPENT(UJPC,LADDR); PLANTADDR(LCIX-2,IC+ICN)
END (* WHILESTATEMENT *);

PROCEDURE FORSTATEMENT;
VAR LATTR: ATTR; LSP: STP; LSY: SYMBOL; LCIX,LADDR: INTEGER;
BEGIN
  IF SY=IDENT THEN
    BEGIN SEARCHID([VARS],LCP);
      LATTR.TYPTR:=LCP^.IDTYPE; LATTR.KIND:=VARBL;
      IF LCP^.VKIND=ACTUAL THEN
        LDAGEN(LCP^.VLEV,LCP^.VADDR)
      ELSE BEGIN ERROR(155); LATTR.TYPTR:=NIL END;
      IF LATTR.TYPTR<>NIL THEN
        IF (LATTR.TYPTR^.FORM>SUBRANGE) (*OR LATTR.TYPTR=REALPTR*) THEN
          BEGIN ERROR(143); LATTR.TYPTR:=NIL END;
      INSYMBOL
    END
  ELSE
    BEGIN ERROR(2); SKIP(FSYS+[BECOMES,TOSY,DOWNTOSY,DOSY]) END;
  IF SY=BECOMES THEN
    BEGIN INSYMBOL; EXPRESSION(FSYS+[TOSY,DOWNTOSY,DOSY]);
      IF GATTR.TYPTR<>NIL THEN
        IF GATTR.TYPTR^.FORM>SUBRANGE THEN ERROR(144)
        ELSE
          IF COMPTYPES(LATTR.TYPTR,GATTR.TYPTR) THEN LOAD
          ELSE ERROR(145)
    END
  ELSE
    BEGIN ERROR(51); SKIP(FSYS+[TOSY,DOWNTOSY,DOSY]) END;
  IF SY IN [TOSY,DOWNTOSY] THEN
    BEGIN LSY:=SY; INSYMBOL; EXPRESSION(FSYS+[DOSY]);
      IF GATTR.TYPTR<>NIL THEN
        IF GATTR.TYPTR^.FORM>SUBRANGE THEN ERROR(144)
        ELSE
          IF COMPTYPES(LATTR.TYPTR,GATTR.TYPTR) THEN
            BEGIN LOAD; LCIX:=LATTR.TYPTR^.SIZE-1;
              IF LSY=DOWNTOSY THEN LCIX:=LCIX+4;
              BYTEGEN(LCIX); LADDR:=IC+ICN;
              GENUJPENT(UJPC,0)
            END
          ELSE ERROR(145)
    END
  ELSE BEGIN ERROR(55); SKIP(FSYS+[DOSY]) END;
  INTEST(DOSY,54);
  STATEMENT(FSYS);
  PLANTADDR(LADDR+1,IC+ICN);
  GENUJPENT(FORPC,LADDR+3)
END (* FORSTATEMENT *);

BEGIN (* STATEMENT *)
  IF NOT(SY IN FSYS+[IDENT]) THEN
    BEGIN ERROR(6); SKIP(FSYS) END;
  IF SY IN STATBEGSYS+[IDENT] THEN
    BEGIN
      PFCTTEST:=FALSE;
      IF SY=IDENT THEN
        BEGIN
          SEARCHID([VARS,FUNC,PROC],LCP); INSYMBOL;
          IF LCP^.KLASS=PROC THEN CALL(FSYS,LCP)
          ELSE ASSIGNMENT(LCP)
        END
       ELSE
        BEGIN LSYM:=SY; INSYMBOL;
          CASE LSYM OF
            BEGINSY:  COMPOUNDSTATEMENT;
            IFSY: IFSTATEMENT;
            WHILESY: WHILESTATEMENT;
            REPEATSY: REPEATSTATEMENT;
            FORSY: FORSTATEMENT;
            CASESY: CASESTATEMENT
          END
        END;
      IF NOT(SY IN [SEMICOLON,ENDSY,ELSESY,UNTILSY]) THEN
        BEGIN ERROR(6); SKIP(FSYS) END
    END
END (* STATEMENT *);

  PROCEDURE SHOWPROGRESS(VAR P:ALPHA);
  VAR M: PACKED ARRAY[1..18] OF CHAR;
    I: INTEGER;
  BEGIN M:="Compiling         ";
  FOR I:=1 TO 8 DO M[I+10]:=P[I];
  MESSAGE(M)
  END (* SHOWPROGRESS *);

BEGIN (* BODY *)
  ENTNAME:=FPROCP^.PFNAME;
  WRITEOUT; CODEBUF[0]:=CHR(4); CODEBUF[1]:=CHR(ENTNAME);
  PUTS(LGO,CODEBUF[0],2);
  PUTS(LGO,FPROCP^.NAME[1],8);
  SHOWPROGRESS(FPROCP^.NAME);
  IC:=0;
  BYTEGEN(ENTPC+LEVEL); ADDRGEN(0);
  LLC1:=-LCAFTERMARKSTACK; LCP:=FPROCP^.NEXT;
  WHILE LCP<>NIL DO
    BEGIN
      IF LCP^.KLASS=VARS THEN
        IF LCP^.IDTYPE<>NIL THEN
          IF LCP^.VKIND=ACTUAL THEN
            IF LCP^.IDTYPE^.FORM>POWER THEN
             BEGIN LLC1:=LLC1-PTRSIZE; LDAGEN(LEVEL,LCP^.VADDR);
               BYTEGEN(LDWPC+LEVEL); BYTEGEN(LLC1);
               OPGEN(MOVEPC); ADDRGEN(LCP^.IDTYPE^.SIZE)
             END
            ELSE LLC1:=LLC1-LCP^.IDTYPE^.SIZE
          ELSE LLC1:=LLC1-PTRSIZE;
      LCP:=LCP^.NEXT;
    END;
  LCMAX:=LC;
  REPEAT
    REPEAT STATEMENT(FSYS+[SEMICOLON,ENDSY])
    UNTIL NOT(SY IN STATBEGSYS);
    TEST:=SY<>SEMICOLON;
    IF NOT TEST THEN INSYMBOL
  UNTIL TEST;
  INTEST(ENDSY,13);
  OPGEN(RETPC); PLANTADDR(1,-LCMAX-LCAFTERMARKSTACK);
END (* BODY *);

BEGIN (* BLOCK *)
  DP:=TRUE;
  REPEAT
    IF SY=CONSTSY THEN
      BEGIN INSYMBOL; CONSTDECLARATION END;
    IF SY=TYPESY THEN
      BEGIN INSYMBOL; TYPEDECLARATION END;
    IF SY=VARSY THEN
      BEGIN INSYMBOL; VARDECLARATION END;
    IF SY=VALUESY THEN
      BEGIN INSYMBOL; VALUEDECLARATION END;
    WHILE SY IN [PROCSY,FUNCSY] DO
      BEGIN LSY:=SY; INSYMBOL; PROCDECLARATION(LSY) END;
    IF SY<>BEGINSY THEN
      BEGIN ERROR(18); SKIP(FSYS) END
  UNTIL SY IN STATBEGSYS;
  DP:=FALSE;
  INTEST(BEGINSY,17);
  REPEAT BODY(FSYS);
    TEST2([FSY],6,FSYS)
  UNTIL (SY=FSY) OR (SY IN BLOCKBEGSYS);
END (* BLOCK *);

