(*$U,P-,T+,R-*)
(* PASCAL M-CODE COMPILER *)
(* COPYRIGHT 1977 , MARK D. RUSTAD *)

PROGRAM PASCALCOMPILER(INPUT,OUTPUT);

CONST DISPLIMIT=15; MAXLEVEL=12; MAXADDR=32767;
  INTSIZE=2; REALSIZE=4; FILESIZE=5;
  CHARSIZE=1; BOOLSIZE=1; SETSIZE=8; PTRSIZE=2;
  STRGLGTH=8; MAXINT=32767; SETMAX=63;
  ALPHASIZE=8; NORWDS=35;
  LCAFTERMARKSTACK=8;
  MAXCHCNT = 120;    (* MAXIMUM INPUT LINE LENGTH *)

  LDASPC=16; LDAPC=32; LDBPC=48; LDWPC=64; STBPC=80; STWPC=96;
  ENTPC=112; LDVPC=32; STVPC=64; SOPPC=128;

TYPE  (* DESCRIBING: *)

  (* BASIC SYMBOLS*)
  (****************)
  SYMBOL=(IDENT,INTCONST,REALCONST,STRINGCONST,NOTSY,MULOP,
    ADDOP,RELOP,LPARENT,RPARENT,LBRACK,RBRACK,COMMA,
    SEMICOLON,PERIOD,ARROW,COLON,BECOMES,DOTDOT,LABELSY,
    CONSTSY,TYPESY,VARSY,FUNCSY,PROGSY,PROCSY,SETSY,PACKEDSY,
    ARRAYSY,RECORDSY,FILESY,EXTERNSY,FORWARDSY,BEGINSY,IFSY,
    CASESY,REPEATSY,WHILESY,FORSY,GOTOSY,ENDSY,ELSESY,UNTILSY,
    OFSY,DOSY,TOSY,DOWNTOSY,THENSY,OTHRWZSY,VALUESY,OTHERSY);

  OPERATOR=(MUL,RDIV,ANDOP,IDIV,IMOD,PLUS,MINUS,OROP,LTOP,
    LEOP,GEOP,GTOP,NEOP,EQOP,INOP,NOOP);

  PCODES=(
    PC00,LDIBPC,LDIWPC,LDISPC,STIBPC,STIWPC,STISPC,LDCPC,LNCPC,
         LCAPC,LDCSPC,LNSPC,SGSPC,DECPC,INCPC,DEC1PC,
    PC10,INC1PC,LTPC,EQPC,LEPC,LTMPC,EQMPC,LEMPC,LTSPC,EQSPC,LESPC,
         FJPC,UJPC,ANDPC,ORPC,NOTPC,
    PC20,DIFPC,INTPC,UNIPC,INPC,CARDPC,ADIPC,DVIPC,MODPC,MPIPC,
         NGIPC,SBIPC,ODDPC,MST0PC,MSTNPC,RETPC,
    PC30,CSPPC,CAPPC,CUP1PC,CUP2PC,FIX21PC,CASEPC,MOVEPC,FORPC,
         GSSPC,ILLPC);

  CSPCODES=(
    WRICSP,WRCCSP,WRSCSP,RDICSP,RLNCSP,RDCCSP,WLNCSP,NEWCSP,
    EFLCSP,RLSCSP,ELNCSP,STPCSP,HLTCSP,MSGCSP,ILLCSP,GETCSP,
    PUTCSP,RSTCSP,RWTCSP);

  SETOFSYS=SET OF SYMBOL;
  INTSET=SET OF 0..SETMAX;

  (* CONSTANTS *)
  (*************)
  CSP=^CONSTANT;
  CONSTANT = RECORD CASE INTEGER OF
               (*SET*) 0: (PVAL: INTSET);
               (*STRING*) 1: (SLGTH: 0..STRGLGTH; SPTR: CSP;
                 SVAL: PACKED ARRAY [1..STRGLGTH] OF 0..127)
             END;
  VALU = RECORD CASE INTEGER OF
           0: (IVAL: INTEGER);
           1: (VALP: CSP)
         END;

  (* DATA STRUCTURES *)
  (*******************)
  LEVRANGE=0..MAXLEVEL; ADDRRANGE=INTEGER;
  STRUCTFORM=(SCALAR,SUBRANGE,POINTER,POWER,ARRAYS,
         RECORDS,FILES);
  DECLKIND=(STANDARD,DECLARED);
  STP=^STRUCTURE; CTP=^IDENTIFIER;
  STRUCTURE=PACKED RECORD
                SIZE: ADDRRANGE;
                STYPE: STP;
                CASE FORM: STRUCTFORM OF
                  SUBRANGE: (MIN,MAX: VALU);
                  ARRAYS: (INXTYPE: STP);
           SCALAR,RECORDS: (FSTFLD: CTP)
              END;

  (* NAMES *)
  (*********)
  IDCLASS=(TYPES,KONST,VARS,FIELD,PROC,FUNC);
  SETOFIDS=SET OF IDCLASS;
  IDKIND=(ACTUAL,FORMAL);
  ALPHA=PACKED ARRAY [1..ALPHASIZE] OF CHAR;
  IDENTIFIER=PACKED RECORD
                NAME: ALPHA; LLINK,RLINK: CTP;
                IDTYPE: STP; NEXT: CTP;
                CASE KLASS: IDCLASS OF
                  KONST: (VALUES: VALU);
                  VARS: (VKIND: IDKIND; VLEV: LEVRANGE;
                    VADDR: ADDRRANGE);
                  PROC,FUNC:
                    (CASE PFDECKIND: DECLKIND OF
                       STANDARD: (KEY: 0..36);
                       DECLARED: (PFLEV: LEVRANGE; PFNAME: INTEGER;
                         FORWDECL: BOOLEAN))
              END;
  DISPRANGE=0..DISPLIMIT;

  (* EXPRESSIONS *)
  (***************)
  ATTRKIND=(CST,VARBL,EXPR);
  VACCESS=(DRCT,INDRCT);
  ATTR=RECORD TYPTR: STP;
           CASE KIND: ATTRKIND OF
             CST: (CVAL: VALU);
             VARBL: (ACCESS: VACCESS; LEVEL: LEVRANGE;
               DPLMT: ADDRRANGE)
         END;

  (* CODEFILE STRUCTURES *)
  (***********************)
  DATAREC =RECORD CASE INTEGER OF
    1: (I:INTEGER);
    2: (A:ALPHA);
    3: (S:SET OF 0..SETMAX)
    END;
  FILENAME=PACKED ARRAY[3..14 ] OF CHAR;
  CODEFILE=FILE OF CHAR;


(*--------------------------------------------------------*)


VAR
  (* RETURNED BY SOURCE PROGRAM SCANNER INSYMBOL: *)
  SY: SYMBOL;      (* LAST SYMBOL *)
  OP: OPERATOR;    (* CLASSIFICATION OF LAST SYMBOL *)
  VAL: VALU;       (* VALUE OF LAST CONSTANT *)
  LGTH: INTEGER;   (* LENGTH OF LAST STRING CONSTANT *)
  ID: ALPHA;       (* LAST IDENTIFIER (POSSIBLY TRUNCATED) *)
  KK: 0..ALPHASIZE; (*NR OF CHARS IN LAST IDENTIFIER *)
  CH: CHAR;        (* LAST CHARACTER *)
  ICH: 0..127;     (* INTEGER OF LAST CHARACTER IN ASCII *)
  LINELENGTH,CHCNT: 0..MAXCHCNT;

  (* EXPRESSION COMPILATION: *)
  (***************************)
  GATTR: ATTR;     (* DESCRIBES THE EXPRESSION BEING COMPILED *)

  (* COUNTERS *)
  (************)
  LC, IC: ADDRRANGE; (* DATA LOCATION AND INST COUNTERS *)
  ICN: INTEGER;
  NPROC: INTEGER;  (* NEXT PROCEDURE NUMBER *)
  I,MXINT10: INTEGER;

  (* SWITCHES *)
  (************)
  DP,              (* DECLARATION PART *)
  PRTERR: BOOLEAN; (* TO ALLOW FORWARD REF. IN POINTER TYPE
                           DECLARATION BY SUPPRESSING ERR MSG *)
  PFCTTEST: BOOLEAN; (* DETECT FUNCTION CALLS IN PARAMETERLISTS *)

  (* POINTERS: *)
  (*************)
  INTPTR,CHARPTR,TEXTPTR,
  BOOLPTR,NILPTR: STP; (* POINTERS TO STD IDS *)
  UTYPPTR,UCSTPTR,UVARPTR,
  UFLDPTR,UPRCPTR,UFCTPTR, (* POINTERS FOR UNDECL. IDS *)
  FWPTR: CTP;      (* HEAD OF CHAIN OF FORW DECL TYPE IDS *)
  PROGPTR: CTP;  (* POINTER TO PROGRAM *)

  (* BOOKKEEPING OF DECLARATION LEVELS: *)
  (**************************************)
  LEVEL: LEVRANGE; (* CURRENT STATIC LEVEL *)
  DISX,            (* LEVEL OF LAST ID SEARCHED BY SEARCHID *)
  TOP: DISPRANGE;  (* TOP OF DISPLAY *)
  SAVETOP: DISPRANGE;  (* SAVE TOP OF DISPLAY *)
  DISPLAY: ARRAY [DISPRANGE] OF CTP;

  (* ERROR MESSAGES: *)
  (*******************)
  ERRINX: 0..10;   (* NR OF ERRORS IN CURRENT SOURCE LINE *)
  ERRLIST:
    ARRAY [1..10] OF
      PACKED RECORD POS: 1..132;
                    NMR: 1..401
             END;

  SPACES: ALPHA;

  (* STRUCTURED CONSTANTS: *)
  (*************************)
  CONSTBEGSYS,SIMPTYPEBEGSYS,TYPEBEGSYS,BLOCKBEGSYS,SELECTSYS,
  VALSPECBEGSYS,FACBEGSYS,STATBEGSYS,TYPEDELS: SETOFSYS;
  RW: ARRAY [0..NORWDS] OF ALPHA;
  FRW: ARRAY [0..ALPHASIZE] OF 0..36;
  RSY: ARRAY [0..NORWDS] OF SYMBOL;
  SSY: ARRAY [' '..'a'] OF SYMBOL;
  ROP: ARRAY [0..NORWDS] OF OPERATOR;
  SOP: ARRAY [' '..'a'] OF OPERATOR;
  NA: ARRAY [0..36] OF ALPHA;

  LINE: PACKED ARRAY [1..MAXCHCNT] OF CHAR; (* LAST SOURCE LINE *)

  (* DISK FILE ARRAYS *)
  (********************)
  CODEBUF: ARRAY[0..127] OF CHAR;
  LGO    : CODEFILE;
  FN     : FILENAME;


(*----------------------------------------------------------*)


 VALUE 

  NA=('FALSE   ','TRUE    ','OUTPUT  ','INPUT   ',
      'GET     ','PUT     ','RESET   ','REWRITE ',
      'READ    ','READLN  ','WRITE   ','WRITELN ',
      'MESSAGE ','PAGE    ','HALT    ','NEW     ',
      'DISPOSE ','RELEASE ','EXIT    ','EOLN    ',
      'EOF     ','ROUND   ','TRUNC   ','ABS     ',
      'SQR     ','ORD     ','CHR     ','PRED    ',
      'SUCC    ','CARD    ','SIN     ','COS     ',
      'EXP     ','SQRT    ','LN      ','ARCTAN  ',
      'ODD     ');

  RW=('IF      ','DO      ','OF      ','IN      ',
      'OR      ','TO      ','END     ','FOR     ',
      'VAR     ','DIV     ','MOD     ','SET     ',
      'AND     ','NOT     ','THEN    ','ELSE    ',
      'TYPE    ','CASE    ','GOTO    ','FILE    ',
      'VALUE   ','BEGIN   ','UNTIL   ','WHILE   ',
      'ARRAY   ','CONST   ','REPEAT  ','RECORD  ',
      'PACKED  ','EXTERN  ','DOWNTO  ','FORWARD ',
      'PROGRAM ','FUNCTION','PROCEDUR','OTHERWIS');

  FRW=(0,0,6,14,20,26,31,33,36);

  RSY=(IFSY     ,DOSY      ,OFSY      ,RELOP     ,
       ADDOP    ,TOSY      ,ENDSY     ,FORSY     ,
       VARSY    ,MULOP     ,MULOP     ,SETSY     ,
       MULOP    ,NOTSY     ,THENSY    ,ELSESY    ,
       TYPESY   ,CASESY    ,GOTOSY    ,FILESY    ,
       VALUESY  ,BEGINSY   ,UNTILSY   ,WHILESY   ,
       ARRAYSY  ,CONSTSY   ,REPEATSY  ,RECORDSY  ,
       PACKEDSY ,EXTERNSY  ,DOWNTOSY  ,FORWARDSY ,
       PROGSY   ,FUNCSY    ,PROCSY    ,OTHRWZSY  );

  SSY=(8 OF OTHERSY, LPARENT, RPARENT, MULOP, (*  !"#$%&'()* *)
       ADDOP, COMMA, ADDOP, PERIOD, MULOP,    (* +,-./ *)
       10 OF OTHERSY, COLON, SEMICOLON, RELOP,(* 0123456789:;< *)
       RELOP, RELOP, 28 OF OTHERSY, LBRACK,   (* =>?@A-Z[ *)
       OTHERSY, RBRACK, ARROW, 3 OF OTHERSY); (* \]^_`a *)

  SOP=(10 OF NOOP, MUL, PLUS, NOOP, MINUS,    (* !"#$%&'()*+,- *)
       NOOP, RDIV, 12 OF NOOP, LTOP, EQOP,    (* .\0123456789:;<= *)
       GTOP, 35 OF NOOP);                     (* >?@A-a *)

  ROP=(NOOP, NOOP, NOOP, INOP, OROP, 4 OF NOOP, IDIV,
       IMOD, NOOP, ANDOP, 23 OF NOOP);

  DISPLAY=(16 OF NIL);
  
  CONSTBEGSYS=[ADDOP,INTCONST,STRINGCONST,IDENT];
  SIMPTYPEBEGSYS=[ADDOP,INTCONST,STRINGCONST,IDENT,LPARENT];
  TYPEBEGSYS= [ARROW,PACKEDSY,ARRAYSY,RECORDSY,SETSY,FILESY,
               ADDOP,INTCONST,STRINGCONST,IDENT,LPARENT];
  TYPEDELS  = [ARRAYSY,RECORDSY,SETSY];
  BLOCKBEGSYS=[CONSTSY,TYPESY,VARSY,VALUESY,PROCSY,FUNCSY,BEGINSY];
  SELECTSYS = [ARROW,PERIOD,LBRACK];
  FACBEGSYS = [INTCONST,STRINGCONST,IDENT,LPARENT,REALCONST,
               LBRACK,NOTSY];
  VALSPECBEGSYS=[ADDOP,INTCONST,STRINGCONST,REALCONST,IDENT,
               LPARENT,LBRACK];
  STATBEGSYS= [BEGINSY,IFSY,WHILESY,REPEATSY,CASESY,FORSY];

  SPACES='        ';

  FWPTR=NIL; DP=TRUE; ERRINX=0; LC=-LCAFTERMARKSTACK;
  NPROC=1; TOP=0; LEVEL=0; IC=0; ICN=0; CH=' '; ICH=32;

(*----------------------------------------------------------*)

  PROCEDURE PUTS(VAR F:CODEFILE; VAR C:CHAR;
      LEN:INTEGER); EXTERN PUTBDATA;
  PROCEDURE SETINPUT(VAR FN:FILENAME); EXTERN;

 (*$ICOMP1.PAS -- INCLUDE I/O PROCEDURES *)
 (*$ICOMP2.PAS -- INCLUDE DECLARATION PROCESSOR *)
 (*$IVALUE.PAS -- INCLUDE VALUE PROCESSOR *)
 (*$ICOMP3.PAS -- INCLUDE PROGRAM BODY PROCESSOR *)

PROCEDURE OPENFILES;
 TYPE EXTENSION=(XBIN,XTXT);
 VAR
   BN: FILENAME;
   I:INTEGER;

  PROCEDURE GETNAME(VAR FN:FILENAME; EX:EXTENSION);
    EXTERN GETFNAME;

 BEGIN
   FOR I:=3 TO 14 DO FN[I]:=COL;
   GETNAME(FN,XTXT); SETINPUT(FN);
   BN:=FN; BN[12]:='B'; BN[13]:='I'; BN[14]:='N';
   GETNAME(BN,XBIN);
   REWRITE(LGO,BN)
 END;

PROCEDURE ENTERSTDTYPES;
BEGIN
  NEW(INTPTR);  (* INTEGER *)
  INTPTR^.SIZE:=INTSIZE; INTPTR^.FORM:=SCALAR; INTPTR^.STYPE:=NIL;
  NEW(CHARPTR); (* CHAR *)
  CHARPTR^.SIZE:=CHARSIZE; CHARPTR^.FORM:=SCALAR; CHARPTR^.STYPE:=NIL;
  NEW(BOOLPTR); (* BOOLEAN *)
  BOOLPTR^.SIZE:=BOOLSIZE; BOOLPTR^.FORM:=SCALAR; BOOLPTR^.STYPE:=NIL;
  NEW(NILPTR);          (* NIL *)
  NILPTR^.STYPE:=NIL; NILPTR^.SIZE:=PTRSIZE; NILPTR^.FORM:=POINTER;
END (* ENTERSTDTYPES *);

PROCEDURE ENTSTDNAMES;
VAR CP,CP1: CTP; I: INTEGER;
BEGIN
  NEW(CP);     (* INTEGER *)
  CP^.NAME:='INTEGER '; CP^.IDTYPE:=INTPTR; CP^.KLASS:=TYPES;
  ENTERID(CP);
  NEW(CP);     (* CHAR *)
  CP^.NAME:='CHAR    '; CP^.IDTYPE:=CHARPTR; CP^.KLASS:=TYPES;
  ENTERID(CP);
  NEW(CP);     (* BOOLEAN *)
  CP^.NAME:='BOOLEAN '; CP^.IDTYPE:=BOOLPTR; CP^.KLASS:=TYPES;
  ENTERID(CP);
  NEW(CP);     (* MAXINT *)
  CP^.NAME:='MAXINT  '; CP^.IDTYPE:=INTPTR; CP^.KLASS:=KONST;
  CP^.VALUES.IVAL:=32767; INTPTR^.FSTFLD:=CP;
  ENTERID(CP);
  NEW(CP);     (* COL=CHR(0) *)
  CP^.NAME:='COL     '; CP^.IDTYPE:=CHARPTR; CP^.KLASS:=KONST;
  CP^.VALUES.IVAL:=0;
  ENTERID(CP);
  CP1:=NIL;
  FOR I:=0 TO 1 DO
    BEGIN NEW(CP);   (* FALSE,TRUE *)
      CP^.NAME:=NA[I]; CP^.IDTYPE:=BOOLPTR; CP^.NEXT:=CP1;
      CP^.VALUES.IVAL:=I; CP^.KLASS:=KONST;
      ENTERID(CP); CP1:=CP
    END;
  BOOLPTR^.FSTFLD:=CP;
  NEW(CP);     (* NIL *)
  CP^.NAME:='NIL     '; CP^.IDTYPE:=NILPTR;
  CP^.NEXT:=NIL; CP^.VALUES.IVAL:=0; CP^.KLASS:=KONST;
  ENTERID(CP);
  FOR I:=4 TO 18 DO
    BEGIN NEW(CP);
      CP^.NAME:=NA[I]; CP^.IDTYPE:=NIL;
      CP^.NEXT:=NIL; CP^.KEY:=I-3;
      CP^.KLASS:=PROC; CP^.PFDECKIND:=STANDARD;
      ENTERID(CP)
    END;
  FOR I:=19 TO 36 DO
    BEGIN NEW(CP);
      CP^.NAME:=NA[I]; CP^.IDTYPE:=NIL; CP^.NEXT:=NIL;
      CP^.KEY:=I-18; CP^.KLASS:=FUNC;
      CP^.PFDECKIND:=STANDARD;
      ENTERID(CP)
    END
END (* ENTSTDNAMES *);

PROCEDURE ENTERUNDECL;
BEGIN
  NEW(UTYPPTR);
  UTYPPTR^.NAME:=SPACES; UTYPPTR^.IDTYPE:=NIL;
  UTYPPTR^.KLASS:=TYPES;
  NEW(UCSTPTR);
  UCSTPTR^.NAME:=SPACES; UCSTPTR^.IDTYPE:=NIL; UCSTPTR^.NEXT:=NIL;
  UCSTPTR^.VALUES.IVAL:=0; UCSTPTR^.KLASS:=KONST;
  NEW(UVARPTR);
  UVARPTR^.NAME:=SPACES; UVARPTR^.IDTYPE:=NIL;
  UVARPTR^.VKIND:=ACTUAL;
  UVARPTR^.NEXT:=NIL; UVARPTR^.VLEV:=0; UVARPTR^.VADDR:=0;
  UVARPTR^.KLASS:=VARS;
  NEW(UFLDPTR);
  UFLDPTR^.NAME:=SPACES; UFLDPTR^.IDTYPE:=NIL; UFLDPTR^.NEXT:=NIL;
  UFLDPTR^.VADDR:=0; UFLDPTR^.KLASS:=FIELD;
  NEW(UPRCPTR);
  UPRCPTR^.NAME:=SPACES; UPRCPTR^.IDTYPE:=NIL;
  UPRCPTR^.FORWDECL:=FALSE;
  UPRCPTR^.NEXT:=NIL; UPRCPTR^.PFLEV:=0; UPRCPTR^.PFNAME:=0;
  UPRCPTR^.KLASS:=PROC; UPRCPTR^.PFDECKIND:=DECLARED;
  NEW(UFCTPTR);
  UFCTPTR^.NAME:=SPACES; UFCTPTR^.IDTYPE:=NIL; UFCTPTR^.NEXT:=NIL;
  UFCTPTR^.FORWDECL:=FALSE; UFCTPTR^.PFLEV:=0; UFCTPTR^.PFNAME:=0;
  UFCTPTR^.KLASS:=FUNC; UFCTPTR^.PFDECKIND:=DECLARED
END (* ENTERUNDECL *);

BEGIN (* INITIALIZE *)
  OPENFILES;
  BEGINLINE;
  MXINT10:=MAXINT DIV 10;
  ENTERSTDTYPES; ENTSTDNAMES; ENTERUNDECL;
  TOP:=1; LEVEL:=1; SAVETOP:=1;
  DISPLAY[1]:=NIL;


  (* COMPILE *)
  (***********)
  INSYMBOL;
  NEW(PROGPTR); PROGPTR^.IDTYPE:=NIL; PROGPTR^.NEXT:=NIL;
  PROGPTR^.KLASS:=PROC; PROGPTR^.PFDECKIND:=DECLARED;
  PROGPTR^.PFNAME:=0; PROGPTR^.NAME:=SPACES;
  IF SY=PROGSY THEN
    BEGIN INSYMBOL;
      IF SY<>IDENT THEN ERROR(2) ELSE PROGPTR^.NAME:=ID;
      WHILE SY<>SEMICOLON DO INSYMBOL;
      INSYMBOL
    END;
  BLOCK(BLOCKBEGSYS+STATBEGSYS,PERIOD,PROGPTR);

  ENDLINE;

  WRITEOUT; CH:=CHR(9); PUTS(LGO,CH,1)
END.
