  PROCEDURE VALUEDECLARATION;
  VAR VALUEHEAD: RECORD C:CHAR; LEN: INTEGER END;
    LCP: CTP; LSP: STP;

    PROCEDURE EMITSTRING(FCSP:CSP);
    VAR I: INTEGER;
    BEGIN 
      WHILE FCSP<>NIL DO
        BEGIN
          FOR I:=1 TO FCSP^.SLGTH DO
            BYTEGEN(FCSP^.SVAL[I]);
          FCSP:=FCSP^.SPTR
        END
    END;

    PROCEDURE CHECKRANGE(FSP1, FSP2: STP; FVALU:VALU);
    VAR LMIN, LMAX: INTEGER;
    BEGIN 
      IF (FSP1<>NIL) AND (FSP2<>NIL) THEN
        IF COMPTYPES(FSP1,FSP2) THEN
          BEGIN 
            IF FSP1^.FORM=SUBRANGE THEN
              BEGIN GETBOUNDS(FSP1,LMIN,LMAX);
                IF (FVALU.IVAL<LMIN) OR (FVALU.IVAL>LMAX) THEN
                  ERROR(303)
              END
          END
        ELSE ERROR(145)
    END;

    PROCEDURE EMITVALUE(LSP,LSP1: STP; FVALU:VALU);
    BEGIN 
      IF LSP<>NIL THEN
        BEGIN CHECKRANGE(LSP,LSP1,FVALU);
          IF STRING(LSP) THEN EMITSTRING(FVALU.VALP)
          ELSE
            IF LSP^.SIZE=2 THEN ADDRGEN(FVALU.IVAL)
            ELSE BYTEGEN(FVALU.IVAL)
        END
    END;

  PROCEDURE VALUESPEC(FSYS: SETOFSYS; FSP:STP);
  VAR LSP,LSP1:STP;
    LVALU:VALU; LSYS:SETOFSYS;

    PROCEDURE SKIPSTRUCTURE(INSY: BOOLEAN);
    BEGIN 
      IF INSY THEN INSYMBOL;
      VALUESPEC(LSYS+[OFSY],NIL);
      WHILE SY IN [COMMA,OFSY] DO
        BEGIN INSYMBOL; VALUESPEC(LSYS+[OFSY],NIL) END
    END;

    PROCEDURE RECORDVALUE;
    VAR LCP: CTP; EXITL: BOOLEAN;
    BEGIN 
      LCP:=FSP^.FSTFLD;
      INSYMBOL;
      IF SY<>RPARENT THEN
        REPEAT
          IF LCP=NIL THEN
            BEGIN ERROR(42); SKIPSTRUCTURE(FALSE) END
          ELSE BEGIN 
            VALUESPEC(LSYS,LCP^.IDTYPE);
            LCP:=LCP^.NEXT
           END;
          EXITL:=SY<>COMMA;
          IF NOT EXITL THEN INSYMBOL
        UNTIL EXITL;
      IF LCP<>NIL THEN ERROR(41)
    END;

    PROCEDURE ARRAYVALUE;
    VAR EL, LMIN,LMAX: INTEGER;
      LSP: STP; STYPE: STP;
      REPCNT: INTEGER;
      REPBLOCK: RECORD C:CHAR; REP, SIZE: INTEGER END;
    BEGIN
      STYPE:=FSP^.STYPE;
      GETBOUNDS(FSP^.INXTYPE,LMIN,LMAX);
      EL:=LMIN;
      REPEAT
        INSYMBOL;
        IF SY IN CONSTBEGSY THEN
          BEGIN CONSTANT(LSYS+[OFSY],LSP,LVALU);
            IF SY=OFSY THEN 
              BEGIN REPCNT:=0;
                IF COMPTYPES(LSP,INTPTR) THEN
                  IF LVALU.IVAL>0 THEN REPCNT:=LVALU.IVAL-1
                  ELSE ERROR(45)
                ELSE ERROR(145);
                INSYMBOL;
                VALUESPEC(LSYS,STYPE);
                IF REPCNT>0 THEN
                  BEGIN WRITEOUT; REPBLOCK.C:=CHR(7);
                    EL:=EL+REPCNT;
                    REPBLOCK.SIZE:=0;
                    IF STYPE<>NIL THEN
                      REPBLOCK.SIZE:=STYPE^.SIZE;
                    REPBLOCK.REP:=REPCNT*REPBLOCK.SIZE;
                    PUTS(LGO,REPBLOCK.C,5)
                  END
              END
            ELSE EMITVALUE(STYPE,LSP,LVALU)
          END
        ELSE (* SY NOT IN CONSTBEGSY *)
          VALUESPEC(LSYS,STYPE);
        IF EL>LMAX THEN
          BEGIN ERROR(42); IF SY=COMMA THEN SKIPSTRUCTURE(TRUE) END;
        EL:=EL+1
      UNTIL SY<>COMMA;
      IF EL<=LMAX THEN ERROR(4)
    END (* ARRAYVALUE *);

    PROCEDURE SETVALUE;
    VAR LOWEL, HIEL: INTEGER; I: INTEGER;
      S: INTSET; D: DATAREC;
      EXITL: BOOLEAN; LSP: STP;

      PROCEDURE SETELEMENT(FSYS: SETOFSYS; VAR ELEMENT: INTEGER);
      VAR LSP1: STP; LVALU: VALU;
      BEGIN 
        CONSTANT(FSYS,LSP1,LVALU);
        ELEMENT:=0;
        IF LSP1<>NIL THEN 
          IF LSP1^.FORM<=SUBRANGE THEN
            BEGIN ELEMENT:=LVALU.IVAL;
              CHECKRANGE(LSP,LSP1,LVALU);
            END
          ELSE ERROR(113)
      END;

    BEGIN (* SETVALUE *)
      S:=[];
      LSP:=NIL;
      IF FSP<>NIL THEN 
        IF FSP^.FORM<>POWER THEN ERROR(145)
        ELSE LSP:=FSP^.STYPE;
      INSYMBOL;
      IF SY<>RBRACK THEN
        REPEAT SETELEMENT(FSYS+[DOTDOT,COMMA,RBRACK],LOWEL);
          IF SY=DOTDOT THEN
            BEGIN INSYMBOL;
              SETELEMENT(FSYS+[COMMA,RBRACK],HIEL);
              S:=S+[LOWEL..HIEL]
            END
          ELSE S:=S+[LOWEL];
          EXITL:=SY<>COMMA;
          IF NOT EXITL THEN INSYMBOL
        UNTIL EXITL;
      D.S:=S;
      FOR I:=1 TO SETSIZE DO BYTEGEN(ORD(D.A[I]));
      INTEST(RBRACK,12)
    END (* SETVALUE *);

  BEGIN (* VALUESPEC *)
    LSYS:=FSYS+[COMMA,RPARENT];
    TEST2(VALSPECBEGSYS,6,FSYS);
    IF SY IN VALSPECBEGSYS THEN
      BEGIN
        IF SY=LPARENT THEN
          BEGIN 
            IF FSP=NIL THEN SKIPSTRUCTURE(TRUE)
            ELSE 
              IF FSP^.FORM=RECORDS THEN RECORDVALUE
              ELSE
                IF FSP^.FORM=ARRAYS THEN ARRAYVALUE
                ELSE BEGIN ERROR(44); SKIPSTRUCTURE(TRUE) END;
            INTEST(RPARENT,4)
          END
        ELSE (* SY<>LPARENT *)
          IF SY=LBRACK THEN SETVALUE
          ELSE
            BEGIN CONSTANT(FSYS,LSP,LVALU);
              EMITVALUE(FSP,LSP,LVALU)
            END;
      TEST1(FSYS,6)
    END
  END (* VALUESPEC *);

  BEGIN (* VALUEDECLARACTION *)
    IF LEVEL=1 THEN 
      BEGIN VALUEHEAD.C:=CHR(5);
        VALUEHEAD.LEN:=LC;
        PUTS(LGO,VALUEHEAD.C,3);
        VALUEHEAD.C:=CHR(6);
        TEST2([IDENT],2,FSYS);
        WHILE SY=IDENT DO
          BEGIN SEARCHID([VARS],LCP);
            IF LCP<>NIL THEN 
              BEGIN LSP:=LCP^.IDTYPE;
                VALUEHEAD.LEN:=LCP^.VADDR
              END;
            PUTS(LGO,VALUEHEAD.C,3);
            INSYMBOL;
            IF OP=EQOP THEN INSYMBOL ELSE ERROR(16);
            VALUESPEC(FSYS+[SEMICOLON],LSP);
            WRITEOUT;
            IF SY=SEMICOLON THEN
              BEGIN INSYMBOL; TEST1(FSYS+[IDENT],6) END
            ELSE ERROR(14)
          END
      END
    ELSE BEGIN ERROR(40); SKIP(FSYS) END
  END (* VALUEDECLARATION *);
